/*
 * vdr-podcatcher - A plugin for the Linux Video Disk Recorder
 * Copyright (c) 2006 Tobias Grimm <vdr@e-tobi.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: stringmessagemock.h 2253 2006-01-23 13:57:24Z svntobi $
 *
 */

#ifndef ___STRINGMESSAGEMOCK_H
#define ___STRINGMESSAGEMOCK_H

#include <string>
#include <vector>
#include <sstream>

class StringMessageMock
{
    private:
        std::vector<std::string> expectations;
        std::vector<std::string> current;
        StringMessageMock* parent;
        std::string messagePrefix;

    private:
        std::string MakeMethodMessage(std::string methodName,
          std::string argument1, std::string argument2);

    protected:
        void AddMessage(std::string message);
        void AddMethod(std::string methodName, std::string argument1 = "",
          std::string argument2 = "");

    public:
        StringMessageMock();
        StringMessageMock(StringMessageMock& parent, std::string messagePrefix = "");

        template <class T>
        std::string MakeString(const T& subject)
        {
            std::stringstream sstream;
            sstream << subject;
            return sstream.str();
        }

        void Expect(std::string expectation);
        void ExpectMethod(std::string methodName, std::string argument1 = "",
          std::string argument2 = "");
        void Verify();
        void ResetMock();
};

#endif
